"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require('react');
var lodash_1 = require('lodash');
var cache_1 = require('./utils/cache');
var get_script_map_1 = require('./utils/get-script-map');
var get_link_1 = require('./utils/get-link');
var get_platform_1 = require('./utils/get-platform');
// export the HEREMap React Component from this module
var HEREMap = (function (_super) {
    __extends(HEREMap, _super);
    function HEREMap() {
        _super.apply(this, arguments);
        this.scriptMap = null;
        this.state = {
            loaded: false,
            map: null,
        };
    }
    HEREMap.prototype.componentDidMount = function () {
        var _this = this;
        this.scriptMap['mapEventsScript'].onLoad(function (err, tag) {
            var _a = _this.props, appId = _a.appId, appCode = _a.appCode, center = _a.center, zoom = _a.zoom;
            var platform = get_platform_1.default(appId, appCode);
            var defaultLayers = platform.createDefaultLayers();
            var map = new H.Map(document.getElementById('mapContainer'), defaultLayers.normal.map, {
                zoom: zoom,
                center: center,
            });
            // make the map interactive
            // MapEvents enables the event system
            // Behavior implements default interactions for pan/zoom
            var behavior = new H.mapevents.Behavior(new H.mapevents.MapEvents(map));
            // create the default UI for the map
            var ui = H.ui.UI.createDefault(map, defaultLayers);
            // attach the map object to the component's state
            _this.setState({
                map: map,
            });
        });
    };
    HEREMap.prototype.componentWillMount = function () {
        this.scriptMap = cache_1.default(get_script_map_1.default());
        var stylesheetUrl = 'http://js.api.here.com/v3/3.0/mapsjs-ui.css';
        get_link_1.default(stylesheetUrl, 'HERE Maps UI');
    };
    HEREMap.prototype.changeCenter = function (point) {
        var map = this.state.map;
        map.setCenter(point, true);
    };
    HEREMap.prototype.componentWillReceiveProps = function (nextProps) {
        if (lodash_1.isEqual(nextProps.center, this.props.center)) {
            this.changeCenter(nextProps.center);
        }
    };
    HEREMap.prototype.render = function () {
        return (React.createElement("div", null, React.createElement("div", {ref: "map", id: "mapContainer", style: { height: '100%' }})));
    };
    return HEREMap;
}(React.Component));
exports.HEREMap = HEREMap;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = HEREMap;
